﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;

namespace HeuristicLab.Algorithms.DataAnalysis {
  public interface ISPTree : IDeepCloneable {

    double[,] Data { set; }
    int GetDepth();
    ISPTree GetParent();
    bool Insert(int newIndex);
    void Subdivide();
    bool IsCorrect();
    void GetAllIndices(int[] indices);
    int GetAllIndices(int[] indices, int loc);
    void ComputeNonEdgeForces(int pointIndex, double theta, double[] negF, double[] sumQ);
    void ComputeEdgeForces(int[] rowP, int[] colP, double[] valP, int n, double[,] posF);

  }
}
